import json
import pulumi

from pulumi.output import Output

from dataclasses import field
from pydantic.dataclasses import dataclass, ConfigDict
from typing import List, Mapping, Optional, Literal
from theia.definitions import AWS_REGION




@dataclass(config=ConfigDict(arbitrary_types_allowed=True))
class ClusterVpcArgs:
    cluster_security_group_id: Optional[str | Output[str]] = None
    endpoint_private_access: Optional[bool] = True
    endpoint_public_access: Optional[bool] = True
    public_access_cidrs: Optional[List[str | Output[str]]] = field(
        default_factory=lambda: ["0.0.0.0/0"]
    )
    security_group_ids: Optional[List[str | Output[str]]] = None
    vpc_id: Optional[str | Output[str]] = None

    def __post_init__(self):
        if not self.endpoint_public_access:
            self.public_access_cidrs = None